'use strict';

var IOFABRIC_VERSION = '0.50';
$(document).ready(function () {
    var accTok = apwGetAccessToken();

    getFogTypesList(accTok).then(function (result) {
        AppWorks_Start();

        $('.modal-trigger').leanModal();
        $('.tooltipped').tooltip({ delay: 50 });

        loadInstances().then(function (res) {
            setupChangeMonitors();
            activateHandlersForFabricInterface();

            $('#fabric-instance-provision-button').click(function () {
                if (selectedInstance != '') {
                    getProvisioningKey(selectedInstance);
                } else {
                    Materialize.toast('No Fog instance is selected.', 5000);
                }
            });

            $('#delete-confirm-modal-yes-button').click(function () {
                if (selectedInstance != '') {
                    $('#deleteconfirmmodal').closeModal();
                    var id = $('.fabric-instance-selected').attr('data-fabric-instance-id');
                    deleteFabricInstance(id);
                } else {
                    Materialize.toast('No Fog instance is selected.', 5000);
                }
            });

            $('#fabric-instance-delete-button').click(function () {
                //showDeleteConfirmModal();
            });
        });
    });
});

var getFogTypesList = function getFogTypesList(accTok) {
    return $.ajax({
        url: fogControllerUrl + ioAuthoring.urls.getFogTypesList + '?t=' + accTok,
        dataType: "json",
        success: function success(res) {
            if (res.status == 'ok') {
                $("#fogTypeContainer").html(ejs.render(ioAuthoring.templates.fogTypeList, { "fogTypes": res.fogTypes }, {}));
            }
        }
    });
};