"use strict";

var toastDelay = 5000;
var counter = 0;
var gridSize = 20;
var accTok = apwGetAccessToken();

// function addBlueBox() {
//     var token = $('#bluebox-token').val();
//     $.ajax({
//         type: "POST",
//         url: ioAuthoring.urls.addBluebox,
//         dataType: "json",
//         data: {t: accTok, token: token},
//         success: function (result) {
//             // var result = $.parseJSON(response);

//             if(result.status == 'ok')
//             {
//                 location.reload();
//             }
//             else
//             {
//                 alert(result.errormessage);
//                 // if(result.ErrorCode == -4)
//                 // {
//                 //     alert("Registration failed: Unable to create fog instance.");
//                 // } else if(result.ErrorCode == -5)
//                 // {
//                 //     alert("Registration failed: Authentication failed.");
//                 // } else if(result.ErrorCode == -6)
//                 // {
//                 //     alert("Registration failed: Please enter a valid token.");
//                 // }
//             }
//         }
//     });
// }


function activateHandlersForInstances() {
    $('.fabric-instance-container').draggable({
        helper: "original",
        opacity: 0.8,
        delay: 200,
        revert: "invalid",
        revertDuration: 400,
        scroll: true,
        containment: 'parent',
        zIndex: 99999,
        start: function start(event, ui) {
            $(".fabric-canvas").css({ "overflow-x": "", "overflow-y": "" });
        },
        stop: function stop(event, ui) {
            $(".fabric-canvas").css({ "overflow-x": "scroll", "overflow-y": "scroll" });
        },
        drag: function drag(event, ui) {
            var topRemainder = ui.position.top % gridSize;
            var leftRemainder = ui.position.left % gridSize;

            if (ui.position.left > 0) {
                ui.position.top = ui.position.top - topRemainder;
                ui.position.left = ui.position.left - leftRemainder;
            }
        }
    });

    $(".fabric-canvas").css({ "overflow-x": "scroll", "overflow-y": "scroll" });
}

function activateHandlersForFabricInterface() {
    //Set up the handlers and immediate actions
    $(".fabric-type-container").draggable({
        helper: "clone",
        opacity: 0.8,
        delay: 200,
        revert: "invalid",
        revertDuration: 400,
        scroll: false,
        zIndex: 99999,
        start: function start(event, ui) {
            $(".fabric-toolbox").css({ "overflow-x": "", "overflow-y": "" });
        },
        stop: function stop(event, ui) {
            $(".fabric-toolbox").css({ "overflow-x": "scroll", "overflow-y": "scroll" });
        },
        drag: function drag(event, ui) {
            var canvasX = $(".fabric-canvas").offset().left;

            var topRemainder = ui.position.top % gridSize;
            var leftRemainder = ui.position.left % gridSize;

            if (ui.position.left > canvasX) {
                ui.position.top = ui.position.top - topRemainder;
                ui.position.left = ui.position.left - leftRemainder;
            }
        }
    });

    $(".fabric-canvas").droppable({
        drop: handleFabricTypeDropOnCanvas
    });

    //This is a hack to work around a scrolling issue with draggable. We will make the toolbar on the left become
    //scrollable AFTER the draggable handler has been added to the toolbar items.
    $(".fabric-toolbox").css({ "overflow-x": "scroll", "overflow-y": "scroll" });
}

function handleFabricTypeDropOnCanvas(event, ui) {
    var canvasX = $(".fabric-canvas").offset().left;

    var fabricX = ui.position.left;
    var fabricY = ui.position.top;

    var posX = Math.floor((fabricX - canvasX) / gridSize) * gridSize;
    var posY = Math.floor(fabricY / gridSize) * gridSize;

    if (ui.draggable.attr('data-fabric-type-id') != undefined) {
        // new instance
        var canvas = $('.fabric-canvas');
        var canvasTop = canvas.scrollTop();
        var canvasLeft = canvas.scrollLeft();

        posX += canvasLeft;
        posY += canvasTop;

        counter++;
        var image = ui.draggable.attr('data-fabric-type-image');
        var fabricType = ui.draggable.attr('data-fabric-type-id');
        createNewInstance(posX, posY, counter, image, fabricType);
    } else {
        // existing instance
        var id = ui.draggable.attr('data-fabric-instance-id');
        updateInstanceLayoutInfo(id, fabricX, fabricY, true);
        ui.draggable.attr('data-fabric-instance-layout-x', fabricX);
        ui.draggable.attr('data-fabric-instance-layout-y', fabricY);
        $('#instance_' + id).css('top', fabricY);
        $('#instance_' + id).css('left', fabricX);
        selectInstance(id);
    }
}

function createNewInstance(posX, posY, tempId, image, fabricType) {
    var name = 'Unnamed ioFog ' + tempId;
    var id = 'TEMP_' + tempId;

    $('.fabric-properties-loading-overlay').css('display', 'visible');
    var tmpFabric = {
        id: id,
        selected: 1,
        posY: posY,
        posX: posX,
        name: name,
        image: '/images/shared/' + image,
        version: '',
        bluetooth: false,
        debug: false,
        viewer: false,
        statusUpdate: 10,
        getChanges: 20
    };
    createElementOnCanvas(tmpFabric);

    $.ajax({
        type: "POST",
        url: fogControllerUrl + ioAuthoring.urls.createFogInstance,
        dataType: "json",
        data: { t: accTok, fabricType: fabricType, name: name, location: "", description: "" },
        success: function success(result) {
            if (result.status == "ok") {
                activateHandlersForInstances();

                var details = result.instance;
                var instanceId = details.uuid;

                $('#fabric-canvas-layout-grid').find('#instance_TEMP_' + tempId).attr('data-fabric-instance-id', instanceId);
                $('#fabric-canvas-layout-grid').find('#instance_TEMP_' + tempId).attr('id', 'instance_' + instanceId);
                $('#display-name-TEMP_' + tempId).attr('id', 'display-name-' + instanceId);
                $('#name-strong-TEMP_' + tempId).attr('id', 'name-strong-' + instanceId);

                $('#fabric-canvas-layout-grid').find('#spinner_' + id).css('display', 'none');
                $('#fabric-canvas-layout-grid').find('#spinner_' + id).attr('id', 'spinner_' + instanceId);

                $('.fabric-properties-loading-overlay').css('display', 'none');

                updateInstanceLayoutInfo(instanceId, posX, posY, 1);

                counter--;

                if (selectedInstance != undefined && selectedInstance != '') {
                    var selectedDiv = $('#instance_' + selectedInstance);
                    selectedDiv.attr('data-fabric-instance-selected', '0');
                    selectedDiv.removeClass('fabric-instance-selected');
                    updateInstanceLayoutInfo(selectedInstance, selectedDiv.attr('data-fabric-instance-layout-x'), selectedDiv.attr('data-fabric-instance-layout-y'), 0);
                }

                selectedInstance = instanceId;

                activateInstanceClickHandler();

                fabricInstanceClickHandler(instanceId);
            }
        }
    });
}

function activateInstanceClickHandler() {
    $(".fabric-instance-container").click(function () {
        var instanceId = $(this).attr('data-fabric-instance-id');
        selectInstance(instanceId);
    });
}

function selectInstance(instanceId) {
    var tmp;
    if (selectedInstance != '') {
        tmp = $('#instance_' + selectedInstance);
        tmp.attr('data-fabric-instance-selected', '0');
        tmp.removeClass('fabric-instance-selected');
        updateInstanceLayoutInfo(selectedInstance, tmp.attr('data-fabric-instance-layout-x'), tmp.attr('data-fabric-instance-layout-y'), false);
    }
    selectedInstance = instanceId;
    tmp = $('#instance_' + instanceId);
    tmp.attr('data-fabric-instance-selected', '1');
    tmp.addClass('fabric-instance-selected');
    fabricInstanceClickHandler(instanceId);
    updateInstanceLayoutInfo(instanceId, tmp.attr('data-fabric-instance-layout-x'), tmp.attr('data-fabric-instance-layout-y'), true);
}

function fabricInstanceClickHandler(instanceId) {
    $('.fabric-properties-loading-overlay').css('display', 'visible');

    $.ajax({
        type: "POST",
        url: fogControllerUrl + ioAuthoring.urls.getFogDetails,
        dataType: "json",
        data: { t: accTok, instanceId: instanceId },
        success: function success(result) {
            if (result.status == "ok") {
                var fabric = result.fog[0];

                var durationTimeStamp = Math.floor(fabric.DaemonOperatingDuration / 1000);

                var rem = durationTimeStamp % 60;
                var durationStr = rem == 0 ? '00' : rem < 10 ? '0' + rem : rem;

                durationTimeStamp = Math.floor(durationTimeStamp / 60);
                if (durationTimeStamp > 0) {
                    rem = durationTimeStamp % 60;
                    durationStr = (rem == 0 ? '00' : rem < 10 ? '0' + rem : rem) + ':' + durationStr;

                    durationTimeStamp = Math.floor(durationTimeStamp / 60);
                    if (durationTimeStamp > 0) {
                        durationStr = durationTimeStamp + ':' + durationStr;
                    } else {
                        durationStr = '00:' + durationStr;
                    }
                } else {
                    durationStr = '00:00:' + durationStr;
                }

                var diskUsage = fabric.DiskUsage * 1;
                var memoryUsage = fabric.MemoryUsage * 1;
                var cpuUsage = fabric.CPUUsage * 1;

                $('#fabric-instance-properties-name').val(fabric.Name);
                $('#fabric-instance-properties-location').val(fabric.Location);
                $('#fabric-instance-properties-description').val(fabric.Description);
                $('#fabric-instance-properties-bluetooth').prop('checked', fabric.Bluetooth == 1 ? true : false);
                $('#fabric-instance-properties-debug').prop('checked', fabric.Debug == 1 ? true : false);
                $('#fabric-instance-properties-viewer').prop('checked', fabric.Viewer == 1 ? true : false);

                $('#fabric-instance-properties-instanceid').text(fabric.UUID);
                $('#fabric-instance-properties-ipaddress').text(fabric.IPAddress);
                $('#fabric-instance-properties-lastactive').text(new Date(fabric.LastActive * 1000).toUTCString());
                $('#fabric-instance-properties-systemtime').text(new Date(fabric.SystemTime * 1).toUTCString());
                $('#fabric-instance-properties-laststatustime').text(new Date(fabric.LastStatusTime * 1).toUTCString());
                $('#fabric-instance-properties-lastcomandtime').text(new Date(fabric.LastCommandTime * 1).toUTCString());
                $('#fabric-instance-properties-fabrictypename').text(fabric.typeName);
                if (fabric.LastStatusTime * 1 < new Date().getTime() - 60000) $('#fabric-instance-properties-daemonstatus').text('UNKNOWN');else $('#fabric-instance-properties-daemonstatus').text(fabric.DaemonStatus);
                $('#fabric-instance-properties-daemonoperatingduration').text(durationStr);
                $('#fabric-instance-properties-daemonlaststarttime').text(new Date(fabric.DaemonLastStart * 1).toUTCString());
                $('#fabric-instance-properties-processedmessages').text(fabric.ProcessedMessages);
                $('#fabric-instance-properties-diskusage').text(diskUsage.toFixed(3) + ' GiB');
                $('#fabric-instance-properties-memoryusage').text(memoryUsage.toFixed(3) + ' MiB');
                $('#fabric-instance-properties-cpuusage').text(cpuUsage.toFixed(2) + '%');

                $('#fabric-instance-properties-networkinterface').text(fabric.NetworkInterface);
                $('#fabric-instance-properties-dockerurl').val(fabric.DockerURL);
                $('#fabric-instance-properties-disklimit').val(fabric.DiskLimit);
                $('#fabric-instance-properties-diskdirectory').val(fabric.DiskDirectory);
                $('#fabric-instance-properties-memorylimit').val(fabric.MemoryLimit);
                $('#fabric-instance-properties-cpulimit').val(fabric.CPULimit);
                $('#fabric-instance-properties-logdirectory').val(fabric.LogDirectory);
                $('#fabric-instance-properties-logdisklimit').val(fabric.LogLimit);
                $('#fabric-instance-properties-logfilecount').val(fabric.LogFileCount);
                $('#fabric-instance-properties-getChanges').val(fabric.ChangeFrequency);
                $('#fabric-instance-properties-statusUpdate').val(fabric.StatusFrequency);

                $('#fabric-instance-properties-provisioningkey').text("-");
            }
            $('.fabric-properties-loading-overlay').css('display', 'none');
        }
    });
}

function updateInstanceLayoutInfo(instanceId, layoutX, layoutY, isSelected) {
    $.ajax({
        type: "POST",
        url: ioAuthoring.urls.updateFogInstanceLayout,
        dataType: "json",
        data: { instanceId: instanceId, layoutX: layoutX, layoutY: layoutY, selected: isSelected == true ? 1 : 0 },
        success: function success(result) {}
    });
}

function getProvisioningKey(instanceId) {
    $.ajax({
        type: "GET",
        url: fogControllerUrl + ioAuthoring.urls.fogProvisioning + instanceId,
        dataType: "json",
        data: {},
        success: function success(result) {
            if (result.status == "ok") {
                var key = result.provisionKey;
                $('#fabric-instance-properties-provisioningkey').text(key);
            }
        },
        error: function error(result) {
            $('#fabric-instance-properties-provisioningkey').text("error");
        }
    });
}

function setupChangeMonitors() {
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-name' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-location' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-description' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-dockerurl' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-disklimit' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-diskdirectory' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-memorylimit' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-cpulimit' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-logdirectory' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-logdisklimit' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-logfilecount' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-statusUpdate' });
    $(document).apwInputChangeMonitor({ 'targetElement': 'fabric-instance-properties-getChanges' });
    $('input[type=text]').blur(function () {
        updateInstanceSetting();
    });
    $('#fabric-instance-properties-bluetooth').change(updateInstanceSetting);
    $('#fabric-instance-properties-debug').change(updateInstanceSetting);
    $('#fabric-instance-properties-viewer').change(updateInstanceSetting);
}

function deleteFabricInstance(instanceId) {
    $.ajax({
        type: "POST",
        url: fogControllerUrl + ioAuthoring.urls.deleteFogInstance,
        dataType: "json",
        data: { t: accTok, instanceId: instanceId },
        success: function success(result) {
            if (result.status == "ok") {
                deleteFogLayouts(result.instanceId).then(function (res) {
                    $('.fabric-instance-selected').remove();
                    selectedInstance = '';
                    var instance = $(".fabric-instance-container");
                    var id = instance.attr("data-fabric-instance-id");
                    if (id != undefined) {
                        scrollToInstance(instance);
                        selectInstance(id);
                    } else {
                        $('#fabric-instance-properties-name').val('');
                        $('#fabric-instance-properties-location').val('');
                        $('#fabric-instance-properties-description').val('');

                        $('#fabric-instance-properties-instanceid').text('-');
                        $('#fabric-instance-properties-ipaddress').text('-');
                        $('#fabric-instance-properties-lastactive').text('-');
                        $('#fabric-instance-properties-systemtime').text('-');
                        $('#fabric-instance-properties-laststatustime').text('-');
                        $('#fabric-instance-properties-lastcomandtime').text('-');
                        $('#fabric-instance-properties-fabrictypename').text('-');
                        $('#fabric-instance-properties-daemonstatus').text('-');
                        $('#fabric-instance-properties-daemonoperatingduration').text('-');
                        $('#fabric-instance-properties-daemonlaststarttime').text('-');
                        $('#fabric-instance-properties-processedmessages').text('-');
                        $('#fabric-instance-properties-diskusage').text('-');
                        $('#fabric-instance-properties-memoryusage').text('-');
                        $('#fabric-instance-properties-cpuusage').text('-');

                        $('#fabric-instance-properties-networkinterface').text('-');
                        $('#fabric-instance-properties-dockerurl').val('-');
                        $('#fabric-instance-properties-disklimit').val('-');
                        $('#fabric-instance-properties-diskdirectory').val('-');
                        $('#fabric-instance-properties-memorylimit').val('-');
                        $('#fabric-instance-properties-cpulimit').val('-');
                        $('#fabric-instance-properties-logdirectory').val('-');
                        $('#fabric-instance-properties-logdisklimit').val('-');
                        $('#fabric-instance-properties-logfilecount').val('-');
                        $('#fabric-instance-properties-statusUpdate').val('-');
                        $('#fabric-instance-properties-getChanges').val('-');
                    }
                });
            }
        }
    });
}

var deleteFogLayouts = function deleteFogLayouts(instanceId) {
    return $.ajax({
        type: "POST",
        url: ioAuthoring.urls.deleteFogInstanceLayout,
        dataType: "json",
        data: { instanceId: instanceId },
        success: function success(result) {}
    });
};

function updateInstanceSetting() {
    var instanceId = $('.fabric-instance-selected').attr('data-fabric-instance-id');
    if (instanceId == null || instanceId == '') return;

    var name = $('#fabric-instance-properties-name').val();

    if (name.trim() == '') {
        Materialize.toast('Fabric name is empty!', 5000);
        $('#fabric-instance-properties-name').focus();
        return;
    }

    var location = $('#fabric-instance-properties-location').val();
    var description = $('#fabric-instance-properties-description').val();
    var eth = $('#fabric-instance-properties-networkinterface').text();
    if (eth.trim() == "") {
        Materialize.toast("Network interface is empty!", 5000);
        $('#fabric-instance-properties-networkinterface').focus();
        return;
    }
    var docker = $('#fabric-instance-properties-dockerurl').val();
    if (docker.trim() == "") {
        Materialize.toast("Docker URL is empty!", 5000);
        $('#fabric-instance-properties-dockerurl').focus();
        return;
    }
    var diskLimit = $('#fabric-instance-properties-disklimit').val();
    if (diskLimit.trim() == "" || isNaN(diskLimit) || diskLimit < 1 || diskLimit > 1048576) {
        Materialize.toast("Disk usage limit is not a valid number between 1 and 1048576 GiB!", 5000);
        $('#fabric-instance-properties-disklimit').focus();
        return;
    }
    var diskDir = $('#fabric-instance-properties-diskdirectory').val();
    if (diskDir.trim() == "") {
        Materialize.toast("Storage directory is empty!", 5000);
        $('#fabric-instance-properties-diskdirectory').focus();
        return;
    }
    var memLimit = $('#fabric-instance-properties-memorylimit').val();
    if (memLimit.trim() == "" || isNaN(memLimit) || memLimit < 128 || memLimit > 1048576) {
        Materialize.toast("Memory usage is not a valid number between 128 and 1048576!", 5000);
        $('#fabric-instance-properties-memorylimit').focus();
        return;
    }
    var cpuLimit = $('#fabric-instance-properties-cpulimit').val();
    if (cpuLimit.trim() == "" || isNaN(cpuLimit) || cpuLimit < 5 || cpuLimit > 100) {
        Materialize.toast("CPU usage limit is not a valid number between 5 and 100!", 5000);
        $('#fabric-instance-properties-cpulimit').focus();
        return;
    }
    var logDir = $('#fabric-instance-properties-logdirectory').val();
    if (logDir.trim() == "") {
        Materialize.toast("Log file directory is empty!", 5000);
        $('#fabric-instance-properties-logdirectory').focus();
        return;
    }
    var logLimit = $('#fabric-instance-properties-logdisklimit').val();
    if (logLimit.trim() == "" || isNaN(logLimit) || logLimit < 0.5 || logLimit > 1024) {
        Materialize.toast("Log disk limit is not a valid number between 0.5 and 1024 GiB!", 5000);
        $('#fabric-instance-properties-logdisklimit').focus();
        return;
    }
    var logCount = $('#fabric-instance-properties-logfilecount').val();
    if (logCount.trim() == "" || isNaN(logCount) || logCount < 1 || logCount > 100 || Math.floor(logCount) != logCount) {
        Materialize.toast("Log file count is not a valid number between 1 and 100!", 5000);
        $('#fabric-instance-properties-logfilecount').focus();
        return;
    }

    var statusUpdate = $('#fabric-instance-properties-statusUpdate').val();
    if (statusUpdate.trim() == "" || isNaN(statusUpdate) || statusUpdate < 1 || Math.floor(statusUpdate) != statusUpdate) {
        Materialize.toast("Status update frequency is not a valid number greater than 1!", 5000);
        $('#fabric-instance-properties-statusUpdate').focus();
        return;
    }

    var getChanges = $('#fabric-instance-properties-getChanges').val();
    if (getChanges.trim() == "" || isNaN(getChanges) || getChanges < 1 || Math.floor(getChanges) != getChanges) {
        Materialize.toast("Get changes frequency is not a valid number greater than 1!", 5000);
        $('#fabric-instance-properties-logfilecount').focus();
        return;
    }

    var bluetooth = $('#fabric-instance-properties-bluetooth').is(':checked') ? true : false;
    var debug = $('#fabric-instance-properties-debug').is(':checked') ? true : false;
    var viewer = $('#fabric-instance-properties-viewer').is(':checked') ? true : false;
    $.ajax({
        type: "POST",
        url: fogControllerUrl + ioAuthoring.urls.fogSettingsUpdate,
        dataType: "json",
        data: {
            t: accTok,
            instanceId: instanceId,
            name: name,
            description: description,
            location: location,
            networkInterface: eth,
            dockerUrl: docker,
            diskLimit: diskLimit,
            diskDirectory: diskDir,
            memoryLimit: memLimit,
            cpuLimit: cpuLimit,
            logLimit: logLimit,
            logDirectory: logDir,
            logFileCount: logCount,
            statusFrequency: statusUpdate,
            changeFrequency: getChanges,
            bluetooth: bluetooth ? 1 : 0,
            debug: debug ? 1 : 0,
            viewer: viewer ? 1 : 0
        },
        success: function success(result) {
            if (result.status == "ok") {
                setObjectName(instanceId, name);
            }
        }
    });

    // $('input[type=text]').each(function() {
    //     var changed = $(this).attr('apwChanged');
    //     if (changed != 'N') {
    //         alert('changed');
    //     }
    // });
}

function scrollToInstance(instance) {
    var canvas = $('.fabric-canvas');

    var canvasTop = canvas.scrollTop();
    var canvasLeft = canvas.scrollLeft();

    var elementTop = instance.attr('data-fabric-instance-layout-y');
    var elementLeft = instance.attr('data-fabric-instance-layout-x');

    if ((elementTop < canvasTop || elementTop > canvas[0].offsetHeight) && (elementLeft < canvasLeft || elementLeft > canvas[0].offsetWidth)) canvas.animate({ scrollTop: Math.max(elementTop - 50, 0), scrollLeft: Math.max(elementLeft - 50, 0) }, 'slow');else if (elementTop < canvasTop || elementTop > canvas[0].offsetHeight) canvas.animate({ scrollTop: Math.max(elementTop - 50, 0) }, 'slow');else if (elementLeft < canvasLeft || elementLeft > canvas[0].offsetWidth) canvas.animate({ scrollLeft: Math.max(elementLeft - 50, 0) }, 'slow');
}

function setObjectName(id, name) {
    var i = 0;
    var displayName = name;
    var tmp = document.getElementById('name-strong-' + id);
    if (tmp != undefined) $(tmp).remove();
    while (true) {
        var p = document.getElementById('display-name-' + id);
        var t = document.createTextNode(displayName);
        var s = document.createElement('strong');
        var sp = document.createElement('span');
        $(sp).attr('id', 'name-span-' + id);
        $(s).attr('id', 'name-strong-' + id);
        s.appendChild(t);
        p.appendChild(s);
        p.appendChild(sp);
        var pLeft = $(p).offset().left;
        var pHeight = $(p).outerHeight();
        var sLeft = $(sp).offset().left;
        i++;
        displayName = name.substring(0, name.length - i) + '...';
        if (sLeft - pLeft <= 148 && pHeight < 25) {
            $(sp).remove();
            break;
        }
        $(s).remove();
        $(sp).remove();
    }
    p.style.display = '';
}

function createElementOnCanvas(fabric) {
    var iofabricVersion = fabric.version == undefined ? "" : fabric.version;

    if (iofabricVersion != "" && parseFloat(iofabricVersion) < parseFloat(IOFABRIC_VERSION)) {
        Materialize.toast('ioFog service for ' + fabric.name + ' is not up to date', toastDelay);
        var backgoundColor = ' style="BACKGROUND-COLOR:#C00000" ';
    }

    var element = '<div class="fabric-instance-container ' + (fabric.selected == 1 ? 'fabric-instance-selected' : '') + '" ' + 'style="top:' + fabric.posY + 'px; left:' + fabric.posX + 'px;" data-fabric-instance-id="' + fabric.id + '" id="instance_' + fabric.id + '" data-fabric-instance-name="' + fabric.name + '" data-fabric-instance-bluetooth="' + fabric.bluetooth + '" data-fabric-instance-debug="' + fabric.debug + '" data-fabric-instance-viewer="' + fabric.viewer + '" data-fabric-instance-statusUpdate="' + fabric.statusUpdate + '" data-fabric-instance-getChanges="' + fabric.getChanges + '" data-fabric-instance-layout-x="' + fabric.posX + '" data-fabric-instance-layout-y="' + fabric.posY + '" data-fabric-instance-selected="' + fabric.selected + '" xmlns="http://www.w3.org/1999/html"><img class="fabric-instance-icon" src="' + fabric.image + '?' + new Date().getTime() + '"><p ' + backgoundColor + ' id="display-name-' + fabric.id + '"><strong id="name-strong-' + fabric.id + '">' + fabric.name + '</strong></p><div style="display:none;" class="fabric-instance-loading-spinner" id="spinner_' + fabric.id + '"><div class="sk-child sk-bounce1"></div><div class="sk-child sk-bounce2"></div><div class="sk-child sk-bounce3"></div></div></div>';
    $("#fabric-canvas-layout-grid").append(element);
}

function loadInstances() {
    return $.ajax({
        type: "POST",
        url: fogControllerUrl + ioAuthoring.urls.fogInstancesList,
        dataType: "json",
        data: { t: accTok },
        success: function success(result) {
            if (result.status == 'ok') {
                var uuids = _.pluck(result.instances, 'UUID');
                getFogLayout(uuids).then(function (res) {
                    var instances = result.instances;
                    for (var i = 0; i < instances.length; i++) {
                        var instance = instances[i];
                        var layoutsData = _.findWhere(res.layoutData, { instanceId: instance.UUID });
                        var fabric = {
                            selected: layoutsData ? layoutsData.isSelected : 0,
                            posY: layoutsData ? layoutsData.layoutY : 0,
                            posX: layoutsData ? layoutsData.layoutX : 0,
                            id: instance.UUID,
                            name: instance.Name,
                            image: '/images/shared/' + instance.typeImage,
                            version: instance.version,
                            bluetooth: instance.bluetooth,
                            debug: instance.debug,
                            viewer: instance.viewer,
                            statusUpdate: instance.StatusFrequency,
                            getChanges: instance.ChangeFrequency
                        };
                        createElementOnCanvas(fabric);
                    }

                    activateHandlersForInstances();
                    activateInstanceClickHandler();

                    //Activate dynamically generated handlers for non-optimal stuff
                    $('.fabric-type-container').each(function (i, div) {
                        var id = $(this).attr('data-fabric-type-id');
                        var last = $('#fabric-type-hover-icon-' + id).attr('last');
                        $(document).apwHoverPopUp({
                            'hoverablesSelector': '#fabric-type-hover-icon-' + id,
                            'width': 300,
                            'height': 300,
                            'offsetLeft': 60,
                            'offsetTop': last == 0 ? -124 : -225,
                            'border': 'N',
                            'borderColor': '#ccc',
                            'solidBackground': 'Y',
                            'backgroundColor': '#eceff1',
                            'fillFromID': 'fabric-type-description-' + id,
                            'hoverPosition': 'right'
                        });
                    });

                    var instance = $(".fabric-instance-container.fabric-instance-selected");
                    var id = instance.attr("data-fabric-instance-id");
                    if (id != undefined) {
                        scrollToInstance(instance);
                        selectInstance(id);
                    }
                });
            }
        }
    });
};

var apwManualPostUpFailedBlank = function apwManualPostUpFailedBlank() {};
var getFogLayout = function getFogLayout(uuids) {
    return $.ajax({
        type: "POST",
        url: ioAuthoring.urls.getFogLayout,
        dataType: "json",
        data: { uuids: uuids },
        success: function success(res) {}
    });
};