'use strict';

$(document).ready(function () {
    var accTok = apwGetAccessToken();

    getFogTypesList(accTok);
    getElementsCatalog(accTok).then(function (res) {
        getElementLayouts(res.elementCatalog).then(function (result) {
            // <!--Turns on modals-->
            AppWorks_Start();
            $('.modal-trigger').leanModal();
            $('#element-properties-configform').trigger('autoresize');

            activateHandlersForPublishingInterface();
            var element;
            for (var i = 0; i < result.layoutData.length; i++) {
                element = result.layoutData[i];
                createNewElementOnCanvas(element.id, element.name, element.fogTypeName, element.picture, element.isSelected, element.layoutX, element.layoutY);
                activateElementsDraggable(element.id);
                activateElementsClickHandler(element.id);
            }
            var instance = $(".element-container.element-selected");
            var id = instance.attr("data-element-id");
            if (id != undefined) {
                scrollToInstance(instance);
                selectElement(id);
            }
        });
    });
});

var getFogTypesList = function getFogTypesList(accTok) {
    return $.ajax({
        url: fogControllerUrl + ioAuthoring.urls.getFogTypesList + '?t=' + accTok,
        dataType: "json",
        success: function success(res) {
            if (res.status == 'ok') {
                $("#fogTypesContainer").html(ejs.render(ioAuthoring.templates.fogTypesList, { "fogTypes": res.fogTypes }, {}));
            }
        }
    });
};

var getElementsCatalog = function getElementsCatalog(accTok) {
    return $.ajax({
        url: fogControllerUrl + ioAuthoring.urls.getElementsForPublish + '?t=' + accTok,
        dataType: "json",
        success: function success(res) {
            if (res.status == 'ok') {}
        }
    });
};

var getElementLayouts = function getElementLayouts(elementCatalog) {
    return $.ajax({
        type: "POST",
        url: ioAuthoring.urls.getElementLayouts,
        dataType: "json",
        data: { elementCatalog: elementCatalog },
        success: function success(result) {}
    });
};